(function($) {

    "use strict";

    $.fn.flimsyslider = function(options) {

        var defaults = {
            speed: 1000,
            pause: 4000
        };        

        options = $.extend(defaults, options);        

        this.each(function() {
        
            //make sure the pause is at least twice as long as the speed
            if(options.pause / options.speed < 2) options.speed = options.pause / 2;

            var $this = $(this); 

            hideCaptions.call($this);

            $this.wrap('<div class="slider-container" />');                        

            //set the ul's width very wide
            $this.css({
                'width': '999999px',
                'position': 'relative'                
            });

            //set li CSS properties
            $this.children().css({
                'float': 'left',
                'list-style': 'none',
                'position': 'relative'
            });

            //set li CSS width - in a function because it's called on window.resize too                                 
            setLiWidth.call($this);

            //move first caption immediately
            moveCaption.call($this, options.speed);
            //move rest of captions/slides
            slideController.call($this, options.speed, options.pause);

            $(window).resize(function() {
                setLiWidth.call($this);
            });

            function getSliderWidth() {                
                return $('.slider-container').width();
            }

            function setLiWidth() {    
                var $this = $(this);
                $this.children().css({
                    'width': getSliderWidth()                  
                });
            }

            function slideLi(sliderWidth, speed) {
                var $this = $(this);
                $this.animate({'left' : '-' + sliderWidth}, speed, function() {                
                    $this.css('left', 0).children(':first').appendTo($this);
                    moveCaption.call($this, sliderWidth, speed);
                });
            }

            function slideController(speed, pause) {
                var $this = $(this);
                setInterval(function() {                   
                    slideLi.call($this, getSliderWidth(), speed);     
                },
                pause);
            }

            function hideCaptions() {       
                this.children().children('.caption').css({
                    'position': 'absolute',
                    'left': getSliderWidth(),
                    'bottom': 0,
                    'display': 'none'
                });
            }

            function moveCaption(speed) {
                var $this = $(this);
                hideCaptions.call($this);
                $this.children(':first').children('.caption').css({'display': 'block'});
                $this.children(':first').children('.caption').animate({'left': 0}, speed / 2);
            }
                    
        });

        

        //console.log("the end: " + this);
            
    };

})(jQuery, window);
